/*
 * HomeView.C
 *
 *  Created on: Jun 4, 2012
 *      Author: rajeev
 */

#include "HomeView.h"
#include <Wt/WContainerWidget>
#include <Wt/WTemplate>
#include <Wt/WApplication>
#include <Wt/WVBoxLayout>
#include <Wt/WText>
#include <Wt/WMenu>
#include <Wt/WStackedWidget>
#include <iostream>

using namespace std;

namespace psa {
using namespace Wt;

class HomeViewImpl : public Wt::WContainerWidget{
private:
	WTemplate* _top_bar;
	WStackedWidget* _main_panel;

public:
    HomeViewImpl(const std::string & basePath){
        WApplication *app = wApp;
//        app->setCssTheme("polished");
        app->messageResourceBundle().use(WApplication::appRoot() + "app");
        app->useStyleSheet("css/app.css");

        _main_panel = new WStackedWidget();
        buildTopBar(basePath);

        _main_panel->setMinimumSize(WLength::Auto,600);

		WVBoxLayout* vLayout = new WVBoxLayout(this);
		vLayout->addWidget(_top_bar);
		vLayout->addWidget(_main_panel,1);
	}


/*	void loggedIn() {
		WApplication::instance()->changeSessionId();

		_top_bar->resolveWidget("login")->show();
		_top_bar->resolveWidget("login-link")->hide();
		_top_bar->resolveWidget("register-link")->hide();

		WText *profileLink = new WText(tr("profile"));
		profileLink->setStyleClass("link");
		profileLink->clicked().connect(this, &HomeViewImpl::editProfile);
		_top_bar->bindWidget("profile-link",profileLink);

		WWidget* contentsLink = buildMenuBar();
		_top_bar->bindWidget("contents-link",contentsLink);

	}

	void loggedOut(){
		_top_bar->bindEmpty("profile-link");

		_top_bar->resolveWidget("login")->hide();
		_top_bar->resolveWidget("login-link")->show();
		_top_bar->resolveWidget("register-link")->show();

		_top_bar->bindEmpty("contents-link");
	}*/

private:
    void buildTopBar(const std::string & basePath)
    {
    	//app->internalPathChanged().connect(this, &HomeViewImpl::handlePathChange);
        _top_bar = new WTemplate(tr("top-bar"));

		WWidget* contentsLink = buildMenuBar();
		_top_bar->bindWidget("contents-link",contentsLink);
    }

    WWidget* buildMenuBar(){
    	WMenu* menus = new WMenu(_main_panel,Wt::Horizontal);

    	menus->addItem("Welcome", buildWelcomeScreen());
    	menus->addItem("News", buildNewsScreen());

    	menus->setStyleClass("contents");

    	menus->select(0);

    	return menus;
    }

    WWidget* buildWelcomeScreen(){
    	return new WTemplate(tr("welcome-screen"));
    }

    WWidget* buildNewsScreen(){
    	return new WTemplate(tr("news-screen"));
    }

};

HomeView::HomeView(const std::string& basePath){
	setImplementation(new HomeViewImpl(basePath));
}

HomeView::~HomeView(){}


}
