#include "HomeView.h"
#include <Wt/WServer>

using namespace Wt;
using psa::HomeView;

class WebApplication : public WApplication
{
public:
  WebApplication(const WEnvironment& env)
    : WApplication(env)
  {
    root()->addWidget(new HomeView("/"));
  }
};


WApplication *createApplication(const WEnvironment& env)
{
  return new WebApplication(env);
}

int main(int argc, char **argv)
{
  try {
    WServer server(argv[0]);

    server.setServerConfiguration(argc, argv, WTHTTP_CONFIGURATION);

    server.addEntryPoint(Application, createApplication);

    if (server.start()) {
      WServer::waitForShutdown();
      server.stop();
    }
  } catch (WServer::Exception& e) {
    std::cerr << e.what() << std::endl;
  } catch (std::exception &e) {
    std::cerr << "exception: " << e.what() << std::endl;
  }
}
